#include "avr8.h"

class Wrapper {

    protected:
        ATMega16 * atmega16;

    public:
    Wrapper() {
        atmega16 = reinterpret_cast<ATMega16 *>(0);

        atmega16->sreg = 0x80; // Global Interrupt Enable

        atmega16->ddrb = 0xff; // Configure PORTB as output
        atmega16->portb = 0xff; // Turn all leds off

        atmega16->admux &= 0x7f; // Select Voltage Reference - AVCC with external capacitor at AREF pin
        atmega16->admux |= 0x20; // Left adjust the result of the ADC
        atmega16->admux &= 0xe0; // Select Analog Channel ADC0 - Single Ended Input

        atmega16->sfior &= 0x1f; // Free Runing Mode

        atmega16->adcsra |= 0x80; // ADC Enable
        atmega16->adcsra |= 0x20; // ADC Auto Trigger Enable
        atmega16->adcsra |= 0x08; // ADC Interrupt Enable
        atmega16->adcsra |= 0x40; // ADC start first conversion
    }

        ~Wrapper(){}

    void handle_adc() {
        atmega16->portb = ~(atmega16->adch); // Print ADC result - leds
    }
};


Wrapper wrapper;

extern "C" {
    void ADC() __attribute__ ((signal)); // ADC Conversion Complete Interrupt Handler
}

void ADC(){
    wrapper.handle_adc();
}

int main() {
    while(1) {}
    return 0;
}
